> For the complete documentation index, see [llms.txt](https://docs.walecloud.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.walecloud.com/api-documentation/events/service-notification.md).

# Service Notification

The `ServiceNotificationEvent` is used to monitor all services in the Cloud.

### Methods

1. **`getNodeId()`** Returns the ID of the node.
2. **`getServiceId()`** Returns the ID of the service.
3. **`getServiceState()`** Returns the state of the service.
4. **`getTemplateId()`** Returns the template ID of the service's template.
5. **`getTemplateName()`** Returns the templae name of the service's template.

{% code title="# Available service states" %}

```java
REQUESTED, PREPARING, CPU_BUSY, STARTING, RUNNING, IN_USE, OFFLINE
```

{% endcode %}

### Code example

```java
@Eventable
public void handle(ServiceNotificationEvent event) {
    ServiceState serviceState = ServiceState.valueOf(event.getServiceState());

    final String templateName = event.getTemplateName();
    final String serviceId = event.getServiceId().substring(0, 5);
    final String nodeId = event.getNodeId() == null ? "Unknown" : event.getNodeId().substring(0, 5);

    switch (serviceState) {
        case REQUESTED -> broadcast("Service %s-%s has been queued".formatted(templateName, serviceId));
        case STARTING -> broadcast("Service %s-%s is now starting on Node-%s".formatted(templateName, serviceId, nodeId));
        case RUNNING -> broadcast("Service %s-%s is now running on Node-%s".formatted(templateName, serviceId, nodeId));
        case OFFLINE -> broadcast("Service %s-%s is now stopping on Node-%s".formatted(templateName, serviceId, nodeId));
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.walecloud.com/api-documentation/events/service-notification.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
